/* Author: Leon Ehrhardt | Universitaet Bremen <s_8vkuts@uni-bremen.de> */

/* Warning: does not work- mutual exclusion not guaranteed (try with numPhil = 1) */

public class Table {

    static final int numPhil = 5;
    
    public static Fork[] forks;
    
    public static void main(String[] args) throws Exception 
    {
        int n = numPhil;
        Philosopher[] philosophers = new Philosopher[n];
        Thread[] threads = new Thread[n];
        for(int i = 0; i < philosophers.length; i++) 
        {
            philosophers[i] = new Philosopher(i);
            //  philosophers[i].start(); does not work
            threads[i] = new Thread(philosophers[i]);
            threads[i].start(); 
        } 

        forks = new Fork[n];
        for(int i = 0; i < forks.length; i++) 
        {
            forks[i] = new Fork();
        }

        for(int i = 0; i < philosophers.length; i++) 
        {
            threads[i].join();
        } 
    }

    public static class Fork 
    {
        Philosopher holder; 

        public void take(Philosopher holder) 
        {
            try {
                do {
                    if(this.holder == null) 
                    {
                        this.holder = holder;
                    }
                    Thread.sleep(10);
                 } 
                 while(this.holder == null);
            } catch(Exception e) {} 
        }

        public void putDown(Philosopher holder) 
        {
            if(this.holder == holder) this.holder = null;
        }

        public Philosopher getHolder() 
        {
            return holder;
        }
    }

    public static class Philosopher implements Runnable 
    {
        private int i = 0; 

        public Philosopher(int i) 
        {
            this.i = i;
        }

        @Override
        public void run() 
        {
            while(true) 
            {
                try {
                    // in milliseconds
                    long time = (long) (Math.random() * 100);
                    System.out.println("Philosopher "+ i+ " starts to think."); 
                    Thread.sleep(time);
                    
                    // try to take forks
                    time =  (long) (Math.random() * 100);
                    Table.forks[i].take(this);
                    Table.forks[(i + 1) % numPhil].take(this); 
                    System.out.println("Philosopher "+ i+ " starts to eat.");
                    Thread.sleep(time);       
                    System.out.println("Philosopher "+ i+ " finished eating.");
                    Table.forks[i].putDown(this);
                    Table.forks[(i + 1) % numPhil].putDown(this); 
                } 
                catch(Exception e) {}
            }
        }

       public int getIndex() 
        {
            return i;
        }
    }
}

