/* Originally from https://medium.com/swlh/the-dining-philosophers-problem-solution-in-c-90e2593f64e8, but that was buggy.  */

#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<unistd.h>

#define MAX_PHIL 10000

pthread_mutex_t chopstick[MAX_PHIL];
int num_phil = 0;

// Sleep up to maxms seconds.
void delay(int maxms)
{
  int s= maxms/2;
  usleep(s+ random() % s);
}

void *philosopher(void *num)
{
  int phil=(*(int *)num);

  // This is odd: *((int *)num)= 5;

  for (;;) {
    printf("Philosopher %d is thinking.\n", phil);	
    // delay(100); 
    printf("Philosopher %d is hungry.\n", phil);	

    /* Pick up forks. */
    pthread_mutex_lock(&chopstick[phil]);
    sched_yield(); // Somebody else can have a go
    pthread_mutex_lock(&chopstick[(phil+1) % num_phil]);

    printf("Philosopher %d is eating.\n", phil);
    delay(200);
    printf("Philosopher %d has finished eating, goes back to thinking.\n", phil);

    /* Put down forks. */
    pthread_mutex_unlock(&chopstick[phil]);
    pthread_mutex_unlock(&chopstick[(phil+1) % num_phil]);
  }
  return NULL;
}

int main(int argc, char *argv[])
{
  int i;
  pthread_t tid[MAX_PHIL];

  if (argc > 1) {
    num_phil= atoi(argv[1]);
  }
  if (num_phil == 0) num_phil= 5;
  printf("We have %d philosophers.\n", num_phil);

  for (i= 0; i< num_phil; i++)
  pthread_mutex_init(&chopstick[i], NULL);
		
  for (i= 0; i< num_phil; i++){
    pthread_create(&tid[i], NULL, philosopher, &i);
    printf("Started philosopher #%d.\n", i);
    }

  // Actually unnessary to wait for *all*, as threads do not terminate.
  for (i= 0; i< num_phil; i++) pthread_join(tid[i], NULL);
}
